﻿Imports Telerik.WinControls.UI
Partial Public Class Form1
    Inherits Form
    Public Sub New()
        InitializeComponent()
        radListView1.ViewType = ListViewType.DetailsView

        Me.radListView1.Columns.Add("Column1")
        Me.radListView1.Columns.Add("Column2")
        Me.radListView1.Columns.Add("Column3")

        Me.RadListView1.ItemSize = New Size(50, 50)
        For i As Integer = 0 To 9
            Dim item As New ListViewDataItem()

            radListView1.Items.Add(item)
        Next
        AddHandler radListView1.CellFormatting, AddressOf radListView1_CellFormatting

        RadListView1.Items(0)(0) = New MyObject(0 & "" & 0, My.Resources.the_music_icon)
        RadListView1.Items(1)(1) = New MyObject(1 & "" & 1, My.Resources.toggle_collapse_basic_blue)
        RadListView1.Items(2)(2) = New MyObject(2 & "" & 2, My.Resources.toggle_expand_basic_blue)

    End Sub

    Private Sub radListView1_CellFormatting(sender As Object, e As ListViewCellFormattingEventArgs)
        Dim cell As DetailListViewDataCellElement = TryCast(e.CellElement, DetailListViewDataCellElement)
        If cell IsNot Nothing Then
            e.CellElement.DrawText = False
            Dim obj As MyObject = TryCast(cell.Row(cell.Data), MyObject)
            If obj IsNot Nothing Then
                e.CellElement.BackgroundImage = obj.myImage
            Else
                e.CellElement.ResetValue(LightVisualElement.BackgroundImageProperty, Telerik.WinControls.ValueResetFlags.Local)
            End If
        Else
            e.CellElement.ResetValue(LightVisualElement.DrawTextProperty, Telerik.WinControls.ValueResetFlags.Local)
            e.CellElement.ResetValue(LightVisualElement.BackgroundImageProperty, Telerik.WinControls.ValueResetFlags.Local)
        End If
    End Sub
End Class

Class MyObject
    Public Sub New(myText As String, myImage As Image)
        Me.myText = myText

        Me.myImage = myImage

    End Sub

    Public Property myText() As String
        Get
            Return m_myText
        End Get
        Set(value As String)
            m_myText = Value
        End Set
    End Property
    Private m_myText As String

    Public Property myImage() As Image
        Get
            Return m_myImage
        End Get
        Set(value As Image)
            m_myImage = Value
        End Set
    End Property
    Private m_myImage As Image

    Public Overrides Function ToString() As String
        Return myText
    End Function
End Class


